package org.mortinious.fortress;

import java.util.ArrayList;

public class FortClaim {

	public FortClaim(FortMain fortmain, String m, int x, int y){
		members = new ArrayList<String>();
		admins = new ArrayList<String>();
		
		main = fortmain;
		
		members.add(m);
		admins.add(m);
		name = m+"'s settlement";
		
		x1 = x-1;
		y1 = y-1;
		
		x2 = x+1;
		y2 = y+1;
	}
	
	public FortClaim(FortMain fortmain, int i, int j, int k, int l, String str){
		members = new ArrayList<String>();
		admins = new ArrayList<String>();

		name = str;
		
		main = fortmain;
		
		x1 = i;
		y1 = j;
		x2 = k;
		y2 = l;
	}
	
	public void expand(int i, int j){
		if(i<x1){
			x1 = i;
		}
		if(j<y1){
			y1 = j;
		}
		if(i>x2){
			x2 = i;
		}
		if(j>y2){
			y2 = j;
		}
	}
	
	public Boolean addMember(String m){
		if(!members.contains(m)){
			members.add(m);
			return true;
		}
		return false;
	}
	
	public Boolean addAdmin(String m){
		if(members.contains(m) && !admins.contains(m)){
			admins.add(m);
			return true;
		}
		return false;
	}
	
	public Boolean hasMember(String name){
		for(int i = 0; i < members.size(); i++){
			if(members.get(i).equals(name)){
				return true;
			}
		}
		return false;
	}
	
	public Boolean hasAdmin(String name){
		for(int i = 0; i < admins.size(); i++){
			if(admins.get(i).equals(name)){
				return true;
			}
		}
		return false;
	}
	
	public Boolean isCoordOnClaim(int i, int j){
		if((i<=x2)&&(i>=x1)&&(j<=y2)&&(j>=y1)){
			return true;
		}
		return false;
	}
	
	public Boolean canBreakBlocks(int i, int j, String s){
		if(isCoordOnClaim(i,j)){
			if(members.contains(s)){
				return true;
			}else{
				for(int n=0; n<main.getServer().getOnlinePlayers().length; n++){
					if(members.contains(main.getServer().getOnlinePlayers()[n].getName())){
					return true;
					}
				}
				return false;
			}
		}
		return true;
	}
	
	public void setName(String s){
		if(s != null){
			name = s;
		}
	}
	
	
	public ArrayList<String> members;
	public ArrayList<String> admins;
	public String name;
	private FortMain main;
	public int x1;
	public int y1;
	public int x2;
	public int y2;
}
