package org.mortinious.fortress;

import org.bukkit.Material;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.player.PlayerMoveEvent;

public class FortListener implements Listener{
	
	public FortListener(FortMain m){
		main = m;
	}
	
	@EventHandler
	public void protectBlock(BlockBreakEvent event){
		if(!main.canBreakBlock(event.getBlock().getX(), event.getBlock().getZ(), event.getPlayer().getName())){
			event.setCancelled(true);
			event.getPlayer().sendMessage("This claim is protected");
		}
	}
	
	@EventHandler
	public void protectDetectorTorch(BlockBreakEvent event){
		if(main.getDetector(event.getBlock().getLocation().getBlockX(), event.getBlock().getLocation().getBlockY()+2, event.getBlock().getLocation().getBlockZ())!=null){
			if(event.getPlayer()!=null){
				event.setCancelled(true);
				event.getPlayer().sendMessage("This torch is part of an detector and cannto be destroyed");	
			}
			else{
				event.getBlock().setType(Material.AIR);
				event.setCancelled(true);
			}
		}
	}
	
	@EventHandler
	public void protectBlockPlacing(BlockPlaceEvent event){
		if(!main.canBreakBlock(event.getBlock().getX(), event.getBlock().getZ(), event.getPlayer().getName())){
			event.setCancelled(true);
			event.getPlayer().sendMessage("This claim is protected");
		}
	}
	
	@EventHandler
	public void enterLeaveClaim(PlayerMoveEvent event){
		
		if((event.getTo().getBlockX() != event.getFrom().getBlockX()) || (event.getTo().getBlockZ() != event.getFrom().getBlockZ())){
			
			if(main.getClaimByCoord(event.getFrom().getBlockX(),event.getFrom().getBlockZ())==null && main.getClaimByCoord(event.getTo().getBlockX(), event.getTo().getBlockZ())!=null){
				event.getPlayer().sendMessage("You are now entering "+main.getClaimByCoord(event.getTo().getBlockX(), event.getTo().getBlockZ()).name);
			}
			
			if(main.getClaimByCoord(event.getFrom().getBlockX(),event.getFrom().getBlockZ())!=null && main.getClaimByCoord(event.getTo().getBlockX(), event.getTo().getBlockZ())==null){
				event.getPlayer().sendMessage("You are now leaving "+main.getClaimByCoord(event.getFrom().getBlockX(), event.getFrom().getBlockZ()).name+" at "+event.getPlayer().getLocation().getBlockY());
			}
			if(main.getDetector(event.getFrom().getBlockX(), event.getFrom().getBlockY(), event.getFrom().getBlockZ())==null && main.getDetector(event.getTo().getBlockX(), event.getFrom().getBlockY(), event.getTo().getBlockZ())!=null){
				main.activateDetector(main.getDetector(event.getTo().getBlockX(), event.getTo().getBlockY(), event.getTo().getBlockZ()), event.getPlayer());
			}
			if(main.getDetector(event.getFrom().getBlockX(), event.getFrom().getBlockY(), event.getFrom().getBlockZ())!=null && main.getDetector(event.getTo().getBlockX(), event.getFrom().getBlockY(), event.getTo().getBlockZ())==null){
				main.deactivateDetector(main.getDetector(event.getFrom().getBlockX(), event.getFrom().getBlockY(), event.getFrom().getBlockZ()), event.getPlayer().getName());
			}
		}
	}
	
	private FortMain main;

}
